#include <windows.h>
#include <gl/gl.h>
LRESULT CALLBACK WindowProc(HWND, UINT, WPARAM, LPARAM);
void EnableOpenGL(HWND hwnd, HDC*, HGLRC*);
void DisableOpenGL(HWND, HDC, HGLRC);
HDC hDC;
int k;
GLfloat x,y,z;
static GLfloat v[] = {
    -14.1605, -7.591, -14.1605,
    14.1605, -7.591, -14.1605,
    14.1605, 7.591, -14.1605,
    -14.1605, 7.591, -14.1605,
    -14.1605, -7.591, 14.1605,
    -14.1605, 7.591, 14.1605,
    14.1605, 7.591, 14.1605,
    14.1605, -7.591, 14.1605,
    -14.1605, -7.591, -14.1605,
    -14.1605, 7.591, -14.1605,
    -14.1605, 7.591, 14.1605,
    -14.1605, -7.591, 14.1605,
    14.1605, -7.591, -14.1605,
    14.1605, -7.591, 14.1605,
    14.1605, 7.591, 14.1605,
    14.1605, 7.591, -14.1605,
    -14.1605, 7.591, -14.1605,
    14.1605, 7.591, -14.1605,
    14.1605, 7.591, 14.1605,
    -14.1605, 7.591, 14.1605,
    -14.1605, -7.591, -14.1605,
    -14.1605, -7.591, 14.1605,
    14.1605, -7.591, 14.1605,
    14.1605, -7.591, -14.1605,
};
static int i[] = {
    0, 2, 1,
    0, 3, 2,
    4, 6, 5,
    4, 7, 6,
    8, 10, 9,
    8, 11, 10,
    12, 14, 13,
    12, 15, 14,
    16, 18, 17,
    16, 19, 18,
    20, 22, 21,
    20, 23, 22,
};
//========================== =============================
//INSERER MES VARIABLES GLOBALES ET MON CODE OPENGL ICI --
float theta = 0.0f;
void MonAffichageEnBoucle()
{
/* OpenGL animation code goes here */
glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
glClear(GL_COLOR_BUFFER_BIT);
glPushMatrix();
glOrtho (-50.0, 50.0, -50.0, 50.0, -50.0, 50.0);
glRotatef(theta, 1.0f, 1.0f, 0.0f);
glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
//glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
glBegin(GL_TRIANGLES);
//0, 2, 1,
glVertex3f(v[0], v[1], v[2]);
glVertex3f(v[6], v[7], v[8]);
glVertex3f(v[3], v[4], v[5]);
//0, 3, 2,
glVertex3f(v[0], v[1], v[2]);
glVertex3f(v[9], v[10], v[11]);
glVertex3f(v[6], v[7], v[8]);
//4, 6, 5,
glVertex3f(v[12], v[13], v[14]);
glVertex3f(v[18], v[19], v[20]);
glVertex3f(v[15], v[16], v[17]);
//4, 7, 6,
glVertex3f(v[12], v[13], v[14]);
glVertex3f(v[21], v[22], v[23]);
glVertex3f(v[18], v[19], v[20]);
// 8, 10, 9,
glVertex3f(v[24], v[25], v[26]);
glVertex3f(v[30], v[31], v[32]);
glVertex3f(v[27], v[28], v[29]);
//8, 11, 10,
glVertex3f(v[24], v[25], v[26]);
glVertex3f(v[33], v[34], v[35]);
glVertex3f(v[30], v[31], v[32]);
//12, 14, 13,
glVertex3f(v[36], v[37], v[38]);
glVertex3f(v[42], v[43], v[44]);
glVertex3f(v[39], v[40], v[41]);
//12, 15, 14,
glVertex3f(v[36], v[37], v[38]);
glVertex3f(v[45], v[46], v[47]);
glVertex3f(v[42], v[43], v[44]);
//16, 18, 17,
glVertex3f(v[48], v[49], v[50]);
glVertex3f(v[54], v[55], v[56]);
glVertex3f(v[51], v[52], v[53]);
//16, 19, 18,
glVertex3f(v[48], v[49], v[50]);
glVertex3f(v[57], v[58], v[59]);
glVertex3f(v[54], v[55], v[56]);
//20, 22, 21,
glVertex3f(v[60], v[61], v[62]);
glVertex3f(v[66], v[67], v[68]);
glVertex3f(v[63], v[64], v[65]);
//20, 23, 22,
glVertex3f(v[60], v[61], v[62]);
glVertex3f(v[69], v[70], v[71]);
glVertex3f(v[66], v[67], v[68]);
glEnd();
glPopMatrix();
SwapBuffers(hDC);
theta += 1.0f;
Sleep (1);
}
// ========================== ===========================
int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmd, int nCmdShow){
WNDCLASSEX wcex;  HWND hwnd;HGLRC hRC; MSG msg; BOOL bQuit = FALSE;
wcex.cbSize = sizeof(WNDCLASSEX); wcex.style = CS_OWNDC;
wcex.lpfnWndProc = WindowProc; wcex.cbClsExtra = 0;
wcex.cbWndExtra = 0; wcex.hInstance = hInst;
wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
wcex.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
wcex.lpszMenuName = NULL; wcex.lpszClassName = "GLSample";
wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);;
if (!RegisterClassEx(&wcex))return 0;
hwnd = CreateWindowEx(0, "GLSample", "OpenGL Sample",
WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
400, 400, NULL, NULL, hInst, NULL); ShowWindow(hwnd, nCmdShow);
EnableOpenGL(hwnd, &hDC, &hRC);
while (!bQuit){
if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
if (msg.message == WM_QUIT){bQuit = TRUE;}else
{TranslateMessage(&msg);DispatchMessage(&msg);}}
else {MonAffichageEnBoucle();}}
DisableOpenGL(hwnd, hDC, hRC);DestroyWindow(hwnd);return msg.wParam;
}
LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
switch (uMsg){
case WM_CLOSE:PostQuitMessage(0);break;
case WM_DESTROY:return 0;
case WM_KEYDOWN:{switch (wParam){case VK_ESCAPE:PostQuitMessage(0);break;}}break;
default:return DefWindowProc(hwnd, uMsg, wParam, lParam);}
return 0;
}
void EnableOpenGL(HWND hwnd, HDC* hDC, HGLRC* hRC){
PIXELFORMATDESCRIPTOR pfd;
int iFormat; *hDC = GetDC(hwnd); ZeroMemory(&pfd, sizeof(pfd));
pfd.nSize = sizeof(pfd); pfd.nVersion = 1;
pfd.dwFlags = PFD_DRAW_TO_WINDOW |PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
pfd.iPixelType = PFD_TYPE_RGBA; pfd.cColorBits = 24; pfd.cDepthBits = 16;
pfd.iLayerType = PFD_MAIN_PLANE;
iFormat = ChoosePixelFormat(*hDC, &pfd); SetPixelFormat(*hDC, iFormat, &pfd);
*hRC = wglCreateContext(*hDC); wglMakeCurrent(*hDC, *hRC);
}
void DisableOpenGL (HWND hwnd, HDC hDC, HGLRC hRC){
wglMakeCurrent(NULL, NULL); wglDeleteContext(hRC); ReleaseDC(hwnd, hDC);
}
